
#include <list>
#include <exception>
#include <stdexcept>
using namespace std;

#include "OverlapController.h"

// IW

//  I@set_OCAƂȂTupdateŐݒ肷B
//  selectŐݒ肳ꂽTQPIĕԂB

template<typename T>
class Selector
{
	list<T> m_candidates; // ȊΏۂƂȂ
	OverlapController<T>* m_OC; // I\bh

public:

	Selector() :
		m_candidates(),
		m_OC(NULL)
	{
		//cout << "Selector(), m_OC:" << m_OC << ", this:" << this << endl;
	}

	Selector(const Selector& other) :
		m_candidates(),
		m_OC(NULL) 
	{
		// gĂOverlapController̓Rs[łȂB
		assert(other.m_candidates.empty());
		assert(other.m_OC == NULL);
		
		// ܂CB
		//  candidates Ƃ[VXeRs[邱ƂlĂȂB
		// 炱VXe͐ňĂ킯BxȂB
	}


	~Selector()
	{
		if ( m_OC != NULL )
		{
			//cout << "~Selector(), m_OC:" << m_OC << ", this:" << this << endl;
			delete m_OC;
			m_OC = NULL;
			//cout << "             m_OC:" << m_OC << ", this:" << this << endl;
		}
	}

	// IΏیXVB
	// i_candidates͍~Ƀ\[gĂAAłĂ͂ȂȂB
	void update_candidates(const list<T>& i_candidates)
	{
		if ( m_OC == NULL )
		{
			//cout << "Selector::update_candidates(), m_OC:" << m_OC << ", this:" << this << endl;
			m_OC = new OC_Random<T>;
			//cout << "                               m_OC:" << m_OC << ", this:" << this << endl;
		}

		#define NOW i_candidates
		#define OLD m_candidates

		typename list<T>::const_iterator now = NOW.begin();
		typename list<T>::iterator old = OLD.begin();

		while (true)
		{
			if ( now == NOW.end() )
			{
				//OLD.erase(old, OLD.end());
				while ( old != OLD.end() )
				{
					m_OC->on_erase(OLD, old);
					old = OLD.erase(old);
				}
				break;
			}
			if ( old == OLD.end() )
			{
				//OLD.insert(old, now, NOW.end());
				for (; now != NOW.end() ; ++now )
				{
					OLD.insert(old, *now);
					m_OC->on_add(OLD, now);
				}
				break;
			}
	
			if ( *now < *old )
			{
				OLD.insert(old, *now);
				m_OC->on_add(OLD, now);
				++now;
			}
			else if ( *now > *old )
			{
				m_OC->on_erase(OLD, old);
				old = OLD.erase(old);
				++old;
			}
			else
			{
				++now;
				++old;
			}
		}
	}
	
	// I󋵂NA
	void clear_OC()
	{
		//cout << "Selector::clear_OC(), m_OC:" << m_OC << ", this:" << this << endl;
		if ( m_OC != NULL )
		{
			m_OC->on_clear();
		}
	}
	
	// I@ύXB
	// ɂ new ō̂nƁB͂̃NXōsB
	void attach_OC(OverlapController<T>* i_OC)
	{
		//cout << "Selector::attach_OC(), m_OC:" << m_OC << ", this:" << this << endl;
		if ( m_OC != NULL )
		{
			delete m_OC;
		}
		m_OC = i_OC;
		//cout << "                       m_OC:" << m_OC << ", this:" << this << endl;
	}
	
	// IsB₪͎̎sĂ͂ȂB
	T select()
	{
		if ( m_OC == NULL )
		{
			//cout << "Selector::select(), m_OC:" << m_OC << ", this:" << this << endl;
			m_OC = new OC_Random<T>;
			//cout << "                    m_OC:" << m_OC << ", this:" << this << endl;
		}

		if ( m_candidates.empty() )
		{
			throw runtime_error("select: candidates list is empty!");
		}
		
		return m_OC->select(m_candidates);
	}
};
